// 円の中心座標を記憶する変数
int cx;
int cy;
// 四角形の左上のXY座標を記憶する変数
int rx;
int ry;

void setup() {
  // 適当にサイズは400x400
  size( 400, 400 );
  // 円の中心座標をランダムに決定する
  cx = (int)random(0, width-60);
  cy = (int)random(0, height-60);
  // 正方形の左上位置をランダムに決定する
  // 画面の右端，下端からはみ出さないように60ずつ引く
  // そして整数に変換する
  rx = (int)random(0, width-60);
  ry = (int)random(0, height-60);
}

void draw() {
  // 準備する
  background( 100 );
  stroke( 0 );
  strokeWeight( 2 );

  // 中か外にあるか判定する
  if ( (cx-25 >= rx && cx + 25 <= rx+60) && (cy-25 >= ry && cy + 25 <= ry+60) ) {
    // 内部にある
    // 黄色で正方形を(rx,ry)の位置に描画する
    fill( 255, 255, 0 );
    rect( rx, ry, 60, 60 );
    // 赤色で円を(cx,cy)の位置に描画する
    fill( 255, 0, 0 );
    ellipse( cx, cy, 50, 50 );
  } 
  else {
    // 外部にある
    // 正方形を(rx,ry)の位置に描画する
    fill( 255 );
    rect( rx, ry, 60, 60 );
    // 円を(cx,cy)の位置に描画する
    fill( 255 );
    ellipse( cx, cy, 50, 50 );
  }

  // 変数の値を表示する
  showIntValue( 1, "cx", cx );
  showIntValue( 2, "cy", cy );
  showIntValue( 3, "rx", rx );
  showIntValue( 4, "ry", ry );
}

void keyPressed() {
  switch( keyCode ) {
  case UP:
    cy = cy - 1;
    break;
  case DOWN:
    cy = cy + 1;
    break;
  case LEFT:
    cx = cx - 1;
    break;
  case RIGHT:
    cx = cx + 1;
    break;
  }
}


// -- 8< - 8< -- ここから下をコピペして使って --- 8< - 8< --------
// 変数の情報を表示するための関数ですので無視してくれて結構です
// 0番から始めて，1，2，3，4と順に下に並んでいきます
// [使い方]
// 整数を表示する場合 showIntValue( 0, "x", x );
// 実数を表示する場合 showIntValue( 0, "面積", r*r*3.14 );
void showIntValue( int num, String name, int value ) {
  showValue( num, name, ""+value );
}

void showFloatValue( int num, String name, float value ) {
  showValue( num, name, ""+value );
}

void showValue( int num, String name, String value ) {
  int margin = 5;
  int unitWidth = 100;
  int unitHeight = 30;
  textSize( 15 );

  stroke( 0 );
  strokeWeight( 1 );
  fill( 255, 100 );
  rect( width-unitWidth*2, num*unitHeight, unitWidth, unitHeight );
  rect( width- unitWidth, num*unitHeight, unitWidth, unitHeight );
  fill( 0 );
  text( name, width-unitWidth*2+margin, (num+1)*unitHeight-margin );
  text( ""+value, width-unitWidth+margin, (num+1)*unitHeight-margin );
}
// -- 8< - 8< -- ここまでコピペして使って --- 8< - 8< ------------

