// 移動速度と角度を記憶する変数を用意
float v = 5.0;
float angle = 0.0;
// 移動中かどうかを記憶するフラグmoving
// 0なら移動していない．1なら移動中
int moving = 0;
// 動く円の中心座標を(mx, my)とする
// 円の座標は角度をつけて微妙に動いていくので実数にしておく
float mx;
float my;
// 3つのターゲットの中心を
int Ax = 100;
int Ay = 200;
int Bx = 500;
int By = 150;
int Cx = 300;
int Cy = 300;
// 目標を何にするか？
// targetが0ならA，1ならB，2ならCとする
int target;

void setup() {
  // 適当に600x400のウインドウを用意
  size( 600, 400 );
  // 最初の動く円の座標をAx, Ayにする
  mx = Ax;
  my = Ay;
  // 現在位置はAなので0をターゲットに
  target = 0;
}

void draw() {
  // 背景などを描画する
  background( 200 );
  fill( 255 );
  stroke( 0 );
  strokeWeight( 3 );
  // 3つのターゲットとなる円を描く
  ellipse( Ax, Ay, 100, 100 );  
  ellipse( Bx, By, 100, 100 );  
  ellipse( Cx, Cy, 100, 100 );

  // 移動中であれば・・・
  if ( moving == 1 ) {
    // 動く円の座標を再計算する
    mx = mx + v * cos(angle);
    my = my + v * sin(angle);

    // ある程度目標とする円の内部に入ったら停止する
    if ( target == 0 && dist( mx, my, Ax, Ay ) < 10 ) {
      // 移動フラグをなしにする
      moving = 0;
    } 
    else if ( target == 1 && dist( mx, my, Bx, By ) < 10 ) {
      // 移動フラグをなしにする
      moving = 0;
    } 
    else if ( target == 2 && dist( mx, my, Cx, Cy ) < 10 ) {
      // 移動フラグをなしにする
      moving = 0;
    }
  }

  // 動く円を描く
  ellipse( mx, my, 50, 50 );

  // 変数の情報を色々表示してみる
  showFloatValue( 1, "mx", mx );
  showFloatValue( 2, "my", my );
  showIntValue( 3, "Ax", Ax );
  showIntValue( 4, "Ay", Ay );
  showIntValue( 5, "Bx", Bx );
  showIntValue( 6, "By", By );
  showIntValue( 7, "Cx", Cx );
  showIntValue( 8, "Cy", Cy );
  showFloatValue( 9, "angle", angle );
  showIntValue( 10, "moving", moving );  
  showIntValue( 11, "target", target );
}

void mousePressed() {
  if ( moving == 0 ) {
    // 移動に関するフラグを立てる
    moving = 1;
    // 目標を次のにする
    target = target + 1;
    // もし目標が2より大きかったら0に戻す
    if ( target > 2 ) {
      target = 0;
    }
    // ターゲットに基づいて角度を計算する
    if ( target == 0 ) {
      angle = atan2( Ay-my, Ax-mx );
    } 
    else if ( target == 1 ) {
      angle = atan2( By-my, Bx-mx );
    } 
    else if ( target == 2 ) {
      angle = atan2( Cy-my, Cx-mx );
    }
  } 
  else {
    // 動いているのであればスルーする
  }
}

// -- 8< - 8< -- ここから下をコピペして使って --- 8< - 8< --------
// 変数の情報を表示するための関数ですので無視してくれて結構です
// 0番から始めて，1，2，3，4と順に下に並んでいきます
// [使い方]
// 整数を表示する場合 showIntValue( 0, "x", x );
// 実数を表示する場合 showIntValue( 0, "面積", r*r*3.14 );
void showIntValue( int num, String name, int value ) {
  showValue( num, name, ""+value );
}

void showFloatValue( int num, String name, float value ) {
  showValue( num, name, ""+value );
}

void showValue( int num, String name, String value ) {
  int margin = 5;
  int unitWidth = 100;
  int unitHeight = 30;
  textSize( 15 );

  stroke( 0 );
  strokeWeight( 1 );
  fill( 255, 100 );
  rect( width-unitWidth*2, num*unitHeight, unitWidth, unitHeight );
  rect( width- unitWidth, num*unitHeight, unitWidth, unitHeight );
  fill( 0 );
  text( name, width-unitWidth*2+margin, (num+1)*unitHeight-margin );
  text( ""+value, width-unitWidth+margin, (num+1)*unitHeight-margin );
}
// -- 8< - 8< -- ここまでコピペして使って --- 8< - 8< ------------

