PFont myFont;
// スロット回転中なら1で，回転していなければ0とする
int rolling;
// くじの状態を格納する変数
int kuji;

void setup() {
  size( 600, 400 );
  myFont = createFont( "Meiryo", 10 );
  textFont( myFont );
  // 最初は回転中ということで1にする
  rolling = 1;
  // くじの結果を表示するための変数には適当に値を設定
  kuji = 0;
}

void draw() {
  // 背景などを準備
  background(200);
  stroke(0);
  fill(255, 255, 0);
  rect( 100, 100, 400, 200 );

  // numの値で占いの表示結果を変える
  // rolling==1のときは，乱数を設定する
  // rolling==0のときは，kujiの値を設定する
  int num;

  if ( rolling == 1 ) {
    // 0から3.99999までの乱数を発生させ，整数に変換する
    num = (int)random(0, 4);
  } 
  else {
    num = kuji;
  }

  switch( num ) {
  case 0:
    textSize(100);
    fill(0);
    text( "大吉", 200, 250 ); 
    // rolling==0の時のみ結果を表示する
    if ( rolling == 0 ) {
      textSize( 30 );
      text( "ラッキー先生は橋本先生", 100, 350 );
    }
    break;
  case 1:
    textSize(100);
    fill(0);
    text( "中吉", 200, 250 );
    // rolling==0の時のみ結果を表示する
    if ( rolling == 0 ) {
      textSize( 30 );
      text( "ラッキー先生は宮下先生", 100, 350 );
    }
    break;
  case 2:
    textSize(100);
    fill(0);
    text( "小吉", 200, 250 ); 
    // rolling==0の時のみ結果を表示する
    if ( rolling == 0 ) {
      textSize( 30 );
      text( "ラッキー先生は小松先生", 100, 350 );
    }
    break;
  case 3:
    textSize(100);
    fill(0);
    text( " 凶 ", 200, 250 );
    // rolling==0の時のみ結果を表示する
    if ( rolling == 0 ) {
      textSize( 30 );
      text( "ラッキー先生は渡邊先生", 100, 350 );
    }
    break;
  }

  // 変数の値を表示する
  showIntValue( 0, "rolling", rolling );
  showIntValue( 1, "kuji", kuji );
  showIntValue( 2, "num", num );
}

void mousePressed() {
  if ( rolling == 1 ) {
    // 0から3.99999までの乱数を発生させ，整数に変換する
    kuji = (int)random(0, 4);
    rolling = 0;
  } 
  else {
    // 回転していないときに再度クリックされると回転中にする
    rolling = 1;
  }
}

// -- 8< - 8< -- ここから下をコピペして使って --- 8< - 8< --------
// 変数の情報を表示するための関数ですので無視してくれて結構です
// 0番から始めて，1，2，3，4と順に下に並んでいきます
// [使い方]
// 整数を表示する場合 showIntValue( 0, "x", x );
// 実数を表示する場合 showIntValue( 0, "面積", r*r*3.14 );
void showIntValue( int num, String name, int value ) {
  showValue( num, name, ""+value );
}

void showFloatValue( int num, String name, float value ) {
  showValue( num, name, ""+value );
}

void showValue( int num, String name, String value ) {
  int margin = 5;
  int unitWidth = 100;
  int unitHeight = 30;
  textSize( 15 );

  stroke( 0 );
  strokeWeight( 1 );
  fill( 255, 100 );
  rect( width-unitWidth*2, num*unitHeight, unitWidth, unitHeight );
  rect( width- unitWidth, num*unitHeight, unitWidth, unitHeight );
  fill( 0 );
  text( name, width-unitWidth*2+margin, (num+1)*unitHeight-margin );
  text( ""+value, width-unitWidth+margin, (num+1)*unitHeight-margin );
}
// -- 8< - 8< -- ここまでコピペして使って --- 8< - 8< ------------

